$ontext
Copyright (C)   2006 Shiro Takeda
Time-stamp:     <2006-11-22 11:17:26 Shiro Takeda>
$Id$
version:
Author:         Shiro Takeda <zbc08106@park.zero.ad.jp>
e-mail:         <zbc08106@park.zero.ad.jp>
First-written:  <2006/10/16>

Commands excecuted before the simulation.

$offtext

$if not setglobal t_ $setglobal t_ t_10

*       ----------------------------------------------------------------------
*       Parameters for HHP Decomposition:
display "com: Parameters for HHP Decomposition:";

set    i_sub	List of policy	/ AGR, SER, MAN, TF /
       i_map
;
display i_sub;
alias (i_sub,ii_sub);

i_map(i,i_sub) = no;
i_map("AGR","AGR") = yes;
i_map("PAG","AGR") = yes;

i_map("SER","SER") = yes;

i_map("NAT","MAN") = yes;
i_map("TAL","MAN") = yes;
i_map("CRP","MAN") = yes;
i_map("WOO","MAN") = yes;
i_map("MVP","MAN") = yes;
i_map("OME","MAN") = yes;
i_map("OMF","MAN") = yes;
i_map("CGDS","MAN") = yes;

i_map("TF","TF") = yes;

display i_map;

parameter
    x0_(i_sub)          Base values of exogenous policy instruments
    deltax_             Total change in policy instruments;

x0_(i_sub) = 1;
deltax_(i_sub) = -0.7;
x0_("tf") = 1;
deltax_("tf") = 0.01;
display x0_, deltax_;

sets    t_              Steps in line integral / t_0*%t_% /
        t_last_(t_)
        t_first_(t_)
parameter       epsilon_        Differentiation perturbation;
display t_;

t_last_(t_)$(ord(t_) eq card(t_)) = yes;
t_first_(t_)$(ord(t_) eq 1) = yes;
display t_last_, t_first_;

epsilon_(i_sub) = 0.1 * deltax_(i_sub) / (card(t_) - 1);
epsilon_("tf") = deltax_("tf") / (card(t_) - 1);
display epsilon_;

*       Declare other decomposition-specific parameters:
parameters
    dt_                     Step size in integral over t_,
    x_(i_sub)               Policy instrument values in the model,
    x(i_sub)                Policy instrument values in the model,
    x_path(t_,i_sub)
    z_                      Current value of EV,
    z0_(t_)                 Values of EV along integral over t_,
    dZdx_(t_,i_sub)         Values of partial derivatives along integral,
    decomp_(i_sub)          Decomposition of EV,
    decomp_path
    decomp_ev(*,*)          Decomposition of EV,
    handshake_              Approximation error,
    pctdecomp_(i_sub)       Decomposition in percentage effects
    isol_                   Solution counter,
    nsol_                   Number of solutions to date;

*   Step size for the line integral:
dt_ = 1 /(card(t_)-1);
display dt_;

*       Generate a status report in the title bar if we are operating
*       on Windows NT/2K/XP:
file title_ /'title.cmd'/; title_.nd=0; title_.nw=0;

*       Turn off the GAMS column, equation and solution listings:
option limrow=0, limcol=0, solprint=off;

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* End:
