$title	The effects of trade liberalization under different market structure.
display "com: The effects of trade liberalization under different market structure.";
$ontext
Copyright (C)   2006 Shiro Takeda
Time-stamp: 	<2006-12-17 17:24:25 Shiro Takeda>
$Id: main.gms,v 1.4 2007/02/19 11:26:53 st Exp $
Author: 	Shiro Takeda <zbc08106@park.zero.ad.jp>
e-mail:		<zbc08106@park.zero.ad.jp>
First-written:	<2004/10/07>
Commentary:

[Acknowledgment]

In writing this program, I have greatly benefited from programs of the Uruguay
round model created by Glenn W. Harrison, Thomas. F. Rutherford, David G. Tarr
and from GTAP6inGAMS package by Thomas. F. Rutherford.  I would like to
express acknowledgment to them.

[Market structure]

PC	Perfect competition model
CD	Cournot model
LGMC	Large group monopolistic competition model (LGMC)
CH	Cournot model with homogeneous varieties
CF	Cournot model with fixed number of firms
QCV	Quantity competition model with non-Cournot conjecutual variation
IC	Integrated market Cournot model
BD	Bertrand competition model
IB	Integrated market Bertrand model

CM	Contestable market model

$offtext

*	----------------------------------------------------------------------
*	Default value of global variables:

*	Experiment name:
$if not setglobal exp_name $setglobal exp_name base

*	The name of GTAP basedata file (without exptension):
$if not setglobal gtap_basedata_file $setglobal gtap_basedata_file basedata

*	The name of GTAP parameter file (without exptension):
$if not setglobal gtap_par_file $setglobal gtap_par_file default

*	The name of parameter file:
$if not setglobal par_file $setglobal par_file parameters_default.par

*	The name of the set definition file:
$if not setglobal set_file $setglobal set_file set_definition.gms

*	The name of services tariff file:
$if not setglobal service_tariff_file $setglobal service_tariff_file tariff_on_services.gms

*	Model choice: set non-zero to the models you want to solve.
$if not setglobal mod_pc $setglobal mod_pc 1
$if not setglobal mod_cd $setglobal mod_cd 1
$if not setglobal mod_lgmc $setglobal mod_lgmc 1
$if not setglobal mod_ch $setglobal mod_ch 1
$if not setglobal mod_cf $setglobal mod_cf 1
$if not setglobal mod_qcv $setglobal mod_qcv 1
$if not setglobal mod_bd $setglobal mod_bd 1
$if not setglobal mod_ic $setglobal mod_ic 1
$if not setglobal mod_ib $setglobal mod_ib 1

$if not setglobal mod_cm $setglobal mod_cm 0

*	The name of a shock file (a file that defines the counter factual
*	experiment):
$if not setglobal shock_file $setglobal shock_file trade_lib.shk

*	Pre-processor file name (a file that is included before the counter
*	factual experiment):
$if not setglobal pre_process $setglobal pre_process pre_proc_default.gms

*	Post-processor file name a file that is included after the counter
*	factual experiment):
$if not setglobal post_process $setglobal post_process post_proc_default.gms

*	Non-zero means the model where CDR is calibrated.
$if not setglobal fl_cdr $setglobal fl_cdr 0

*	If non-zero, only execute calibraion:
$if not setglobal calib_only $setglobal calib_only 0

*	If non-zero, only execute benchmark replication:
$if not setglobal br_only $setglobal br_only 0

*	If non-zero, only execute cleanup calculation (+ benchmark
*	replication):
$if not setglobal cc_only $setglobal cc_only 0

*	Flag for assuming all sectors are imperfect competion.  If non-zero,
*	all sectors is assumed to be an imperfectly competitive sector.
$if not setglobal fl_allimp $setglobal fl_allimp 0

*	Scale factor for Armington-variety elasticity (default is unity):
$if not setglobal sc_eos $setglobal sc_eos 1

*	Value of benchmark CDR:
$if not setglobal cdr $setglobal cdr 0.15

*	The benchmark number of firms (valid only in model QCV and CDR
*	calibration model).
$if not setglobal n_0 $setglobal n_0 20

*	Tariff on service trade.  If not zero, tariffs on service trade are
*	introduced.
$if not setglobal fl_ser $setglobal fl_ser 1

*	Solver for solving the model (non-zero means MCP, otherwise NLP)
$if not setglobal fl_mcp $setglobal fl_mcp 1

*	Solver for calibration (non-zero means MCP, otherwise NLP)
$if not setglobal fl_mcp_c $setglobal fl_mcp_c 1

*	Alternative model for model IB.
$if not setglobal fl_ib_alt $setglobal fl_ib_alt 0

*	Non-zero means constant beta:
$if not setglobal fl_beta $setglobal fl_beta 0

*	Value of price elasticity of Armington demand:
$if not setglobal v_eod $setglobal v_eod 0.5

*	MCP solver:
$if not setglobal solver_mcp $setglobal solver_mcp path

*	NLP solver:
$if not setglobal solver_nlp $setglobal solver_nlp pathnlp

*	The number of iteration limit (iterlim):
$if not setglobal iter_lim $setglobal iter_lim 10000

*	Alternative fixed cost specification (this does not work well).
$if not setglobal fl_fc_alt $setglobal fl_fc_alt 0

display "exp_name =		%exp_name%";
display "gtap_basedata_file =	%gtap_basedata_file%";
display "gtap_par_file =	%gtap_par_file%";
display "par_file =		%par_file%";
display "set_file =		%set_file%";
display "service_tariff_file =	%service_tariff_file%";
display "mod_pc =		%mod_pc%";
display "mod_cd =		%mod_cd%";
display "mod_lgmc =		%mod_lgmc%";
display "mod_ch =		%mod_ch%";
display "mod_cf =		%mod_cf%";
display "mod_qcv =		%mod_qcv%";
display "mod_bd =		%mod_bd%";
display "mod_ic =		%mod_ic%";
display "mod_ib =		%mod_ib%";
display "mod_cm =		%mod_cm%";
display "shock_file =		%shock_file%";
display "post_process =		%post_process%";
display "fl_cdr =		%fl_cdr%";
display "calib_only =		%calib_only%";
display "br_only =		%br_only%";
display "cc_only =		%cc_only%";
display "fl_allimp =		%fl_allimp%";
display "sc_eos =		%sc_eos%";
display "cdr =			%cdr%";
display "n_0 =			%n_0%";
display "fl_ser =		%fl_ser%";
display "fl_mcp =		%fl_mcp%";
display "fl_mcp_c =		%fl_mcp_c%";
display "fl_ib_alt =		%fl_ib_alt%";
display "fl_beta =		%fl_beta%";
display "v_eod =		%v_eod%";
display "solver_mcp =		%solver_mcp%";
display "solver_nlp =		%solver_nlp%";
display "iter_lim =		%iter_lim%";
display "fl_fc_alt =		%fl_fc_alt%";

*	----------------------------------------------------------------------
*	Option setting:

*	Solver choice for MCP problem:
option mcp = %solver_mcp%;

*	Solver choice for NLP problem:
option nlp = %solver_nlp%;

*	Decimal number:
option decimals = 6;

*	Limit reports:
option limrow=0, limcol=0;

*	Resource limit:
option reslim = 3000;

*	----------------------------------------------------------------------
*	Include gams-f library
$sysinclude gams-f

*	----------------------------------------------------------------------
*	Parameter and set definition:

*	Model list:
set ms_all	Model list	/ PC, CD, LGMC, CH, CF, QCV, BD, IC, CM, IB /
    ms(ms_all)	Type of market structure
    /
$if not %mod_pc%==0	PC         Perfect competition
$if not %mod_cd%==0	CD         Cournot model
$if not %mod_lgmc%==0	LGMC       Large group monopolistic competition
$if not %mod_ch%==0	CH         Cournot model with homogeneous varieties
$if not %mod_cf%==0	CF         Cournot model with fixed number of firms
$if not %mod_qcv%==0	QCV        Quantity competition model with non-Cournot conjecutual variation
$if not %mod_bd%==0	BD         Bertrand model
$if not %mod_ic%==0	IC         Integrated market Cournot model
$if not %mod_ib%==0	IB         Integrated market Bertrand model
$if not %mod_cm%==0	CM         Contestable market model
/
    c_ms(ms_all)	Current market structure
;
parameter
    fl_q	Flag for Quantity competition		/ 0 /
    fl_p	Flag for Price competition		/ 0 /
    fl_lgmc	Flag for LGMC				/ 0 /
    fl_cm	Flag for contestable market		/ 0 /
    fl_h	Flag for homogeneous goods		/ 0 /
    fl_fix	Flag for fixed number of firms		/ 0 /
    fl_int	Flag for integrated market		/ 0 /
    fl_qcv	Flag for non-zero conjecutual variation	/ 0 /
    fl_ib_alt	/ %fl_ib_alt% /
    fl_cdr	/ %fl_cdr% /
    fl_ser	/ %fl_ser% /
    fl_mcp	Solver choice for the model		/ %fl_mcp% /
    fl_mcp_c	Solver choice for calibration		/ %fl_mcp_c% /
    fl_beta	/ %fl_beta% /
    fl_fc_alt	/ %fl_fc_alt% /

    calib_only	/ %calib_only% /
    cc_only	/ %cc_only% /
    br_only	/ %br_only% /
;
display calib_only, br_only, cc_only;

*	These sets are assigned non-zero if calibration and computation fail.
set    calib_fail(ms_all)	List of models that fail calibration
       solve_fail(ms_all)	List of models that cannot be solved
;
calib_fail(ms_all) = no;
solve_fail(ms_all) = no;
display calib_fail, solve_fail;

parameter
       calib_fail_par		List of models that fail calibration
       solve_fail_par		List of models that cannot be solved
;
calib_fail_par(ms_all) = 0;
solve_fail_par(ms_all) = 0;

*	File name for displaying title in DOS window.
file titlemaker /'%exp_name%_titlemaker.cmd'/;

*	----------------------------------------------------------------------
*	Data and model:
display "com: Data and model";
$include ..\sub_model.gms

*	----------------------------------------------------------------------
*	Pre-processor:
$if exist .\%pre_process% $include .\%pre_process%

*	----------------------------------------------------------------------
*	Solving models:
display "com: Solving models:";

*	Loop starts here.
loop(ms,

    c_ms(ms_all) = no;
    c_ms(ms) = yes;
    display c_ms;

*	Set parameters according to model type:
$include ..\sub_model_choice.gms

*	----------------------------------------------------------------------
*	Execute calibration.
    display "com: Execute calibration";

    if((not calib_only), option solprint = off);
$include  ..\sub_calibration.gms
    if((not calib_only), option solprint = on);
*     display fl_int, fl_q, fl_p;

$if not %calib_only%==0 $goto post

    if(calib_fail(ms),
	display "com: Calibration fails!!!!!  So, skip the rest of the program.";
	display calib_fail;
    else
*	----------------------------------------------------------------------
*	Import lower bound and initial value
	display "com: Import lower bound and initial value";
$include ..\sub_initial_values.gms

*	----------------------------------------------------------------------
*	Benchmark replication.
	display "com: Benchmark replication.";
	putclose titlemaker
	'@title Experiment = %exp_name%, Benchmark replication, model type = ', ms.tl:0;
	execute '%exp_name%_titlemaker.cmd';

	if((not br_only), option solprint = off);
	if(fl_mcp,
	    gtap_trade_lib_mcp.iterlim = 0;
	    solve gtap_trade_lib_mcp using mcp;
	else
	    gtap_trade_lib_nlp.iterlim = 0;
	    solve gtap_trade_lib_nlp using nlp minimizing dum_obj;
	);
	if((not br_only), option solprint = on);

*	Set numeraire:
  	inc_ra.fx(rnum) = inc_ra.l(rnum);

$if not %br_only%==0 $goto post

*	----------------------------------------------------------------------
*	Cleanup calculation.
	display "com: Cleanup calculation.";

	putclose titlemaker
	    '@title Experiment = %exp_name%, Cleanup calculation, model type = ', ms.tl:0;
	execute '%exp_name%_titlemaker.cmd';

	if((not cc_only), option solprint = off);
	if(fl_mcp,
	    gtap_trade_lib_mcp.iterlim = %iter_lim%;
	    solve gtap_trade_lib_mcp using mcp;
	else
	    gtap_trade_lib_nlp.iterlim = %iter_lim%;
	    solve gtap_trade_lib_nlp using nlp minimizing dum_obj;
	);
	if((not cc_only), option solprint = on);
	display "benchmark tolerance:", gtap_trade_lib_mcp.objval;

$if not %cc_only%==0 $goto post

*	----------------------------------------------------------------------
*	Shock:
	display "com: Shcok:";

*	Import shock file:
$include .\%shock_file%

	if(solve_fail(ms),
*	If the model cannot be solved, initialize variables.
$include ..\sub_initial_values.gms
	);

$label post

*	----------------------------------------------------------------------
*	Output results:
$include ..\sub_output_results.gms

    );

*	----------------------------------------------------------------------
$label end

    if(calib_fail(ms), calib_fail_par(ms) = 1);
    if(solve_fail(ms), solve_fail_par(ms) = 1);

*	Reset c_ms.
    c_ms(ms_all) = no;

);

*	----------------------------------------------------------------------
*	Post processor:
$if exist .\%post_process% $include .\%post_process%

*	Delete unnecessary files.
$libinclude delete '%exp_name%_titlemaker.cmd'

display "com: --- Program ends here ---";

* --------------------
* Local Variables:
* mode: gams
* fill-column: 78
* tab-width: 8
* End:
